/+dub.sdl:
dependency "libev" version="~>5.0.0+4.04"
+/

import deimos.ev;

import core.thread;
import core.sys.posix.netinet.in_;
import core.sys.posix.netinet.tcp;
import core.sys.posix.unistd;
import core.sys.posix.fcntl;
import core.stdc.stdlib;
import std.conv;
import std.stdio;
import std.socket;
import std.random;
import std.range.primitives;

void* buffer;
enum BUFFER_SIZE = 8192;

void main(string[] args)
{
    ushort port = args.length > 1 ? to!ushort(args[1]) : 8080;
    writeln("0.0.0.0:", port);
    auto addr = new InternetAddress("0.0.0.0", port);
    immutable uint on = 1;
    auto socket = socket(AddressFamily.INET, SocketType.STREAM, ProtocolType.TCP);
    setsockopt(socket, SocketOptionLevel.SOCKET, SO_REUSEADDR, &on, on.sizeof);
    setsockopt(socket, SocketOptionLevel.SOCKET, SO_REUSEPORT, &on, on.sizeof);
    setsockopt(socket, SocketOptionLevel.SOCKET, SO_KEEPALIVE, &on, on.sizeof);
    
   bind(socket, addr.name, addr.nameLen);
    listen(socket, 1);
    fcntl(socket, F_SETFL, fcntl(socket, F_GETFL, 0) | O_NONBLOCK);


    buffer = malloc(BUFFER_SIZE);

    auto loop = ev_loop_new(0);

    ev_set_syserr_cb(&err);

    ev_io* serverIo = cast(ev_io*)malloc(ev_io.sizeof);
    ev_io_init(serverIo, &serverCb, socket, EV_READ);
    ev_io_start(loop, serverIo);

    ev_run(loop, 0);
    free(serverIo);
    free(buffer);
}

extern (C){
	void err(const(char*) msg){
        writeln("ERROR----------------");
    }
    
    void serverCb(ev_loop_t* loop, ev_io* serverIo, int){
        auto socket = accept(serverIo.fd, null, null);
        writeln("new connect");
        fcntl(socket, F_SETFL, fcntl(socket, F_GETFL, 0) | O_NONBLOCK);

        auto io = cast(ev_io*)malloc(ev_io.sizeof);
     
        io.data = calloc(1, MyIo.sizeof);
        ev_io_init(io, &clientCb, socket, EV_READ);
        ev_io_start(loop, io);
    }
    void clientCb(ev_loop_t* loop, ev_io* io, int revent){
        //writeln("work");
        auto myIo = cast(MyIo*)io.data;
        if ((revent & EV_READ) == EV_READ){
            writeln("read");
            long received;
            received = recv(io.fd, buffer, BUFFER_SIZE, SocketFlags.NONE);
            if (received == 0){
                return closeFd(loop, io);
            }
      
            myIo.bufferOut = cast(void[])"HTTP/1.0 200 OK\nContent-Type: text/html; charset=utf-8\n\nOK\n";
     
            ev_io_stop(loop, io);
            ev_io_set (io, io.fd, EV_READ | EV_WRITE);
            ev_io_start(loop, io);
        }
        if ((revent & EV_WRITE) == EV_WRITE){
            writeln("write");
            if (myIo.bufferOut.empty){
       
                return closeFd(loop, io);
            }
            long sended;
            sended = send(io.fd, myIo.bufferOut.ptr, myIo.bufferOut.length, SocketFlags.NONE);
            if (sended > 0){
                myIo.bufferOut = myIo.bufferOut[sended..$];
            }
            if (myIo.bufferOut.empty){
        
                return closeFd(loop, io);
            }
        }
    }
}
void closeFd(ev_loop_t* loop, ev_io* io){
    writeln("end");
    ev_io_stop(loop, io);
    shutdown(io.fd, SocketShutdown.BOTH);
    close(io.fd);
    free(io.data);
    free(io);
}
struct MyIo {
    void[] bufferIn;
    void[] bufferOut;
}